Index: src/main/java/com/xpn/xwiki/api/AccessLevel.java
===================================================================
--- src/main/java/com/xpn/xwiki/api/AccessLevel.java	(revision 0)
+++ src/main/java/com/xpn/xwiki/api/AccessLevel.java	(revision 0)
@@ -0,0 +1,254 @@
+/*
+ * Copyright 2004-2007, XpertNet SARL, and individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+ *
+ * This distribution includes the following modules:
+ *
+ * http://jakarta.apache.org: velocity, struts, jrcs, commons, etc..
+ * This distribution also includes libraries from the Apache Software
+ * Foundation distributed under the terms of the Apache Software License.
+ * See http://www.opensource.org/licenses/apachepl.php
+ *
+ * http://www.hibernate.org:
+ * This distribution includes libraries from hibernate.org distributed
+ * under the terms of the Lesser General Public License.
+ * See http://www.gnu.org/copyleft/lesser.html
+ *
+ * http://www.junit.org
+ * This distribution includes libraries from junit.org distributed 
+ * under the terms of the Common Public License
+ * See http://www.opensource.org/licenses/cpl.php
+ *
+ * ===================================================================
+ */
+package com.xpn.xwiki.api;
+
+import java.util.ArrayList;
+import java.util.Iterator;
+import java.util.List;
+
+/**
+ * Enumerated class to manage the access levels used in xwiki, such as "view", "edit", "login", etc.
+ * Two lists are maintained for the access levels: "regular" access levels, to be used for 
+ * documents/spaces and "global" access levels, used for global access level settings.  
+ * 
+ * @author Anca-Paula Luca
+ */
+public class AccessLevel
+{
+    //put the constants here
+    public static final AccessLevel VIEW = new AccessLevel("view", true, true);
+    public static final AccessLevel LOGIN = new AccessLevel("login", false, false);
+    public static final AccessLevel DOWNLOAD = new AccessLevel("download", false, false);
+    public static final AccessLevel DELETE = new AccessLevel("delete", false, true);
+    public static final AccessLevel COMMENT = new AccessLevel("comment", true, true);
+    public static final AccessLevel REGISTER = new AccessLevel("register", false, true);
+    public static final AccessLevel ADMIN = new AccessLevel("admin", false, true);
+    public static final AccessLevel EDIT = new AccessLevel("edit", true, true);
+    public static final AccessLevel PROGRAMMING = new AccessLevel("programming", false, true);
+        
+    /**
+     * holds the list of accessLevels that can be set for a given document / space.
+     */
+    private static List regularAccessLevels;
+    /**
+     * holds the list of accessLevels that can be set for the entire wiki.
+     * The present assignment of levels to categories has been done according to the code in 
+     * {@link com.xpn.xwiki.objects.classes.LevelsClass#getList(com.xpn.xwiki.XWikiContext)}. 
+     */
+    private static List globalAccessLevels;
+    /**
+     * array holding all the constants defined by this class.
+     */
+    private static ArrayList values;    
+        
+    /**
+     * The string value of this right. e.g. "view", "admin", "edit"
+     */
+    private String rightString;
+    
+    /**
+     * Returns a new instance of an AccessLevel from the given string value, trimmed and lowercased.
+     *  
+     * @param right the String value of the right. 
+     * @param isRegular specifies wheather this is a regular access level.
+     * @param isGlobal specifies wheather this is a global access level.
+     */
+    private AccessLevel(String right, boolean isRegular, boolean isGlobal) 
+    {
+        this.rightString = right.trim().toLowerCase();
+        if (isRegular) {
+            if (AccessLevel.regularAccessLevels == null) {
+                AccessLevel.regularAccessLevels = new ArrayList();
+            }
+            //put it in the regularAccessLevels
+            AccessLevel.regularAccessLevels.add(this);
+        }
+        if (isGlobal) {
+            if (AccessLevel.globalAccessLevels == null) {
+                AccessLevel.globalAccessLevels = new ArrayList();
+            }
+            //put it in the globals list
+            AccessLevel.globalAccessLevels.add(this);
+        }
+        //put it in the values array
+        if (AccessLevel.values == null) {
+            AccessLevel.values = new ArrayList();
+        }
+        AccessLevel.values.add(this);
+    }
+    
+    /**
+     * @return all the access level constants provided by this class.
+     */
+    public static AccessLevel[] values() 
+    {
+        AccessLevel[] valuesToReturn = new AccessLevel[AccessLevel.values.size()];
+        AccessLevel.values.toArray(valuesToReturn);
+        return valuesToReturn;
+    }
+    
+    /**
+     * @return true if an access level matching <tt>rightString</tt> is found, and false otherwise.
+     * The comparison is made with the trimmed and lowercased value of rightString. 
+     */
+    public static boolean isAccessLevelDefined(String rightString) {
+        String cleanRightString = rightString.trim().toLowerCase();
+        for (Iterator it = AccessLevel.values.iterator(); it.hasNext();) {
+            AccessLevel current = (AccessLevel)it.next();
+            if (current.getRightString().equals(cleanRightString)) {
+                return true;
+            }
+        }
+        return false;
+    }
+    
+    /**
+     * Returns the AccessLevel constant matching rightString. if such a constant does not exist, it 
+     * is created and then returned. The newly created access level is not a regular nor a global 
+     * access level. To create an access level and specify it's type, use 
+     * {@link AccessLevel#valueOf(String, boolean, boolean)}.
+     * 
+     * @param rightString the String value of the access level.
+     * @return the matching constant, or a newly created AccessLevel object if no match is found.
+     * 
+     * @see AccessLevel#valueOf(String, boolean, boolean) 
+     */
+    public static AccessLevel valueOf(String rightString) 
+    {
+        String cleanRightString = rightString.trim().toLowerCase();
+        for (Iterator it = AccessLevel.values.iterator(); it.hasNext();) {
+            AccessLevel current = (AccessLevel)it.next();
+            if (current.getRightString().equals(cleanRightString)) {
+                return current;
+            }
+        }
+        //create a new accessLevel, that defaults on false, false
+        return new AccessLevel(rightString, false, false);
+    }
+    
+    /**
+     * Behaves like {@link AccessLevel#valueOf(String)}, only that, upon the creation of the new
+     * AccessLevel object, <tt>isRegular</tt> and <tt>isGlobal</tt> are used to specify the type 
+     * of this access level.
+     * <br />
+     * Note that this function does not change the type of an existing AccessLevel: if a match for 
+     * <tt>stringRight</tt> is found, <tt>isRegular</tt> and <tt>isGlobal</tt> are ignored.
+     * 
+     * @see AccessLevel#valueOf(String)
+     */
+    public static AccessLevel valueOf(String stringRight, boolean isRegular, boolean isGlobal) {
+        String cleanRightString = stringRight.trim().toLowerCase();
+        for (Iterator it = AccessLevel.values.iterator(); it.hasNext();) {
+            AccessLevel current = (AccessLevel)it.next();
+            if (current.getRightString().equals(cleanRightString)) {
+                return current;
+            }
+        }
+        //create a new accessLevel, that defaults on false, false
+        return new AccessLevel(stringRight, isRegular, isGlobal);        
+    }
+
+    public String getRightString()
+    {
+        return rightString;
+    }
+    
+    public int hashCode()
+    {
+        return this.rightString.hashCode();
+    }
+    
+    public String toString()
+    {
+        return this.rightString;
+    }
+    
+    public static List listRegularAccessLevels() {
+        return new ArrayList(AccessLevel.regularAccessLevels);
+    }
+    
+    public static List listGlobalAccessLevels() {
+        return new ArrayList(AccessLevel.globalAccessLevels);
+    }
+
+    public static AccessLevel getADMIN()
+    {
+        return ADMIN;
+    }
+
+    public static AccessLevel getCOMMENT()
+    {
+        return COMMENT;
+    }
+
+    public static AccessLevel getDELETE()
+    {
+        return DELETE;
+    }
+
+    public static AccessLevel getDOWNLOAD()
+    {
+        return DOWNLOAD;
+    }
+
+    public static AccessLevel getEDIT()
+    {
+        return EDIT;
+    }
+
+    public static AccessLevel getLOGIN()
+    {
+        return LOGIN;
+    }
+
+    public static AccessLevel getPROGRAMMING()
+    {
+        return PROGRAMMING;
+    }
+
+    public static AccessLevel getREGISTER()
+    {
+        return REGISTER;
+    }
+
+    public static AccessLevel getVIEW()
+    {
+        return VIEW;
+    }
+}
Index: src/main/java/com/xpn/xwiki/api/XWiki.java
===================================================================
--- src/main/java/com/xpn/xwiki/api/XWiki.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/api/XWiki.java	(working copy)
@@ -101,7 +101,7 @@
     public Document getDocument(String fullname) throws XWikiException
     {
         XWikiDocument doc = xwiki.getDocument(fullname, getXWikiContext());
-        if (xwiki.getRightService().hasAccessLevel("view", getXWikiContext().getUser(),
+        if (xwiki.getRightService().hasAccessLevel(AccessLevel.VIEW, getXWikiContext().getUser(),
             doc.getFullName(), getXWikiContext()) == false) {
             return null;
         }
@@ -123,24 +123,34 @@
     }
 
     /**
+     * @see XWiki#checkAccess(String, DocumentAction)
+     * @deprecated use {@link XWiki#checkAccess(String, DocumentAction)}
+     */
+    public boolean checkAccess(String docname, String right)
+    {
+        DocumentAction action = DocumentAction.valueOf(right);
+        return this.checkAccess(docname, action);
+    }
+    
+    /**
      * Verify the rights the current user has on a document. If the document requires rights and the
      * user is not authenticated he will be redirected to the login page.
      * 
      * @param docname fullname of the document
-     * @param right right to check ("view", "edit", "admin", "delete")
+     * @param right right to check
      * @return true if it exists
      */
-    public boolean checkAccess(String docname, String right)
+    public boolean checkAccess(String docname, DocumentAction action)
     {
         try {
             XWikiDocument doc = new XWikiDocument();
             doc.setFullName(docname, getXWikiContext());
-            return getXWikiContext().getWiki().checkAccess(right, doc, getXWikiContext());
+            return getXWikiContext().getWiki().checkAccess(action, doc, getXWikiContext());
         } catch (XWikiException e) {
             return false;
         }
     }
-
+    
     /**
      * Loads an Document from the database. Rights are checked before sending back the document.
      * 
@@ -152,7 +162,7 @@
     public Document getDocument(String web, String fullname) throws XWikiException
     {
         XWikiDocument doc = xwiki.getDocument(web, fullname, getXWikiContext());
-        if (xwiki.getRightService().hasAccessLevel("view", getXWikiContext().getUser(),
+        if (xwiki.getRightService().hasAccessLevel(AccessLevel.VIEW, getXWikiContext().getUser(),
             doc.getFullName(), getXWikiContext()) == false) {
             return null;
         }
@@ -174,7 +184,7 @@
         if ((doc == null) || (doc.getDoc() == null))
             return null;
 
-        if (xwiki.getRightService().hasAccessLevel("view", getXWikiContext().getUser(),
+        if (xwiki.getRightService().hasAccessLevel(AccessLevel.VIEW, getXWikiContext().getUser(),
             doc.getFullName(), getXWikiContext()) == false) {
             // Finally we return null, otherwise showing search result is a real pain
             return null;
@@ -947,7 +957,7 @@
                 registerRight = true;
             } else {
                 registerRight =
-                    xwiki.getRightService().hasAccessLevel("register",
+                    xwiki.getRightService().hasAccessLevel(AccessLevel.REGISTER,
                         getXWikiContext().getUser(), "XWiki.XWikiPreferences", getXWikiContext());
             }
 
@@ -1304,22 +1314,42 @@
     }
 
     /**
+     * @see XWiki#hasAccessLevel(AccessLevel)
+     * @deprecated use {@link XWiki#hasAccessLevel(AccessLevel)} 
+     */
+    public boolean hasAccessLevel(String level)
+    {
+        AccessLevel accessLevel = AccessLevel.valueOf(level);
+        return this.hasAccessLevel(accessLevel);
+    }
+
+    /**
      * API to check rights on the current document for the current user
      * 
      * @param level right to check (view, edit, comment, delete)
      * @return true if right is granted/false if not
      */
-    public boolean hasAccessLevel(String level)
+    public boolean hasAccessLevel(AccessLevel level)
     {
         try {
             return xwiki.getRightService().hasAccessLevel(level, getXWikiContext().getUser(),
                 getXWikiContext().getDoc().getFullName(), getXWikiContext());
         } catch (Exception e) {
             return false;
-        }
+        }        
     }
 
     /**
+     * @see XWiki#hasAccessLevel(AccessLevel, String, String) 
+     * @deprecated use {@link XWiki#hasAccessLevel(AccessLevel, String, String)}
+     */
+    public boolean hasAccessLevel(String level, String user, String docname)
+    {
+        AccessLevel accessLevel = AccessLevel.valueOf(level);
+        return this.hasAccessLevel(accessLevel, user, docname);
+    }
+    
+    /**
      * v * API to check rights on a document for a given user
      * 
      * @param level right to check (view, edit, comment, delete)
@@ -1327,14 +1357,14 @@
      * @param docname document on which to check the rights
      * @return true if right is granted/false if not
      */
-    public boolean hasAccessLevel(String level, String user, String docname)
+    public boolean hasAccessLevel(AccessLevel level, String user, String docname) 
     {
         try {
             return xwiki.getRightService()
                 .hasAccessLevel(level, user, docname, getXWikiContext());
         } catch (Exception e) {
             return false;
-        }
+        }        
     }
 
     /**
@@ -1537,7 +1567,7 @@
      */
     public String getURL(String fullname) throws XWikiException
     {
-        return xwiki.getURL(fullname, "view", getXWikiContext());
+        return xwiki.getURL(fullname, DocumentAction.VIEW, getXWikiContext());
     }
 
     /**
@@ -1553,10 +1583,20 @@
      * @return a URL as a string pointing to the wiki document in view mode
      * @throws XWikiException if the URL could not be generated properly
      */
-    public String getURL(String fullname, String action) throws XWikiException
+    public String getURL(String fullname, DocumentAction action) throws XWikiException
     {
         return xwiki.getURL(fullname, action, getXWikiContext());
     }
+    
+    /**
+     *  @see XWiki#getURL(String, DocumentAction)
+     *  @deprecated use {@link XWiki#getURL(String, DocumentAction)} 
+     */
+    public String getURL(String fullname, String action) throws XWikiException
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getURL(fullname, documentAction);
+    }    
 
     /**
      * API to retrieve the URL of an a Wiki Document in any mode, optionally adding a query string
@@ -1574,11 +1614,22 @@
      * @return a URL as a string pointing to the wiki document in view mode
      * @throws XWikiException if the URL could not be generated properly
      */
-    public String getURL(String fullname, String action, String querystring)
+    public String getURL(String fullname, DocumentAction action, String querystring)
         throws XWikiException
     {
         return xwiki.getURL(fullname, action, querystring, getXWikiContext());
     }
+    
+    /**
+     *  @see XWiki#getURL(String, DocumentAction, String)
+     *  @deprecated use {@link XWiki#getURL(String, DocumentAction, String)} 
+     */
+    public String getURL(String fullname, String action, String querystring)
+        throws XWikiException
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getURL(fullname, documentAction, querystring);
+    }    
 
     /**
      * @see #getExoService(String)
@@ -1723,11 +1774,21 @@
      * @return A DocumentStats object with number of actions performed, unique visitors, number of
      *         visits
      */
-    public DocumentStats getCurrentMonthXWikiStats(String action)
+    public DocumentStats getCurrentMonthXWikiStats(DocumentAction action)
     {
         return getXWikiContext().getWiki().getStatsService(getXWikiContext()).getDocMonthStats(
             "", action, new Date(), getXWikiContext());
     }
+    
+    /**
+     * @see XWiki#getCurrentMonthXWikiStats(DocumentAction)
+     * @deprecated use {@link XWiki#getCurrentMonthXWikiStats(DocumentAction)}
+     */
+    public DocumentStats getCurrentMonthXWikiStats(String action)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getCurrentMonthXWikiStats(documentAction);
+    }
 
     /**
      * API to retrieve a viewable referer text for a referer Referers are URL where users have
@@ -1988,17 +2049,27 @@
     /**
      * Returns the recently visited pages for a specific action
      * 
-     * @param action ("view" or "edit")
+     * @param action ({@link DocumentAction#VIEW} or {@link DocumentAction#EDIT})
      * @param size how many recent actions to retrieve
      * @return a ArrayList of document names
      */
-    public java.util.Collection getRecentActions(String action, int size)
+    public java.util.Collection getRecentActions(DocumentAction action, int size)
     {
         XWikiStatsService stats = getXWikiContext().getWiki().getStatsService(getXWikiContext());
         if (stats == null)
             return new ArrayList();
         return stats.getRecentActions(action, size, getXWikiContext());
     }
+    
+    /**
+     * @see XWiki#getRecentActions(DocumentAction, int)
+     * @deprecated use {@link XWiki#getRecentActions(DocumentAction, int)} 
+     */
+    public java.util.Collection getRecentActions(String action, int size)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getRecentActions(documentAction, size);
+    }    
 
     /**
      * Returns the Advertisement system from the preferences
@@ -2334,10 +2405,10 @@
     {
         try {
             if (xwiki.exists(newFullName, getXWikiContext())
-                && !xwiki.getRightService().hasAccessLevel("delete", getXWikiContext().getUser(),
+                && !xwiki.getRightService().hasAccessLevel(AccessLevel.DELETE, getXWikiContext().getUser(),
                     newFullName, getXWikiContext()))
                 return false;
-            if (xwiki.getRightService().hasAccessLevel("edit", getXWikiContext().getUser(),
+            if (xwiki.getRightService().hasAccessLevel(AccessLevel.EDIT, getXWikiContext().getUser(),
                 doc.getFullName(), getXWikiContext())) {
                 xwiki.renamePage(doc.getFullName(), newFullName, getXWikiContext());
             }
Index: src/main/java/com/xpn/xwiki/pdf/impl/PdfURLFactory.java
===================================================================
--- src/main/java/com/xpn/xwiki/pdf/impl/PdfURLFactory.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/pdf/impl/PdfURLFactory.java	(working copy)
@@ -22,6 +22,7 @@
 package com.xpn.xwiki.pdf.impl;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.web.XWikiServletURLFactory;
@@ -35,7 +36,7 @@
     public PdfURLFactory() {
     }
 
-    public URL createAttachmentURL(String filename, String web, String name, String action, String querystring, String xwikidb, XWikiContext context) {
+    public URL createAttachmentURL(String filename, String web, String name, DocumentAction action, String querystring, String xwikidb, XWikiContext context) {
         try {
             File tempdir = (File) context.get("pdfexportdir");
             File file = new File(tempdir, web + "." + name + "." + filename);
Index: src/main/java/com/xpn/xwiki/XWiki.java
===================================================================
--- src/main/java/com/xpn/xwiki/XWiki.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/XWiki.java	(working copy)
@@ -75,8 +75,10 @@
 import org.hibernate.HibernateException;
 import org.securityfilter.filter.URLPatternMatcher;
 
+import com.xpn.xwiki.api.AccessLevel;
 import com.xpn.xwiki.api.Api;
 import com.xpn.xwiki.api.Document;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.api.User;
 import com.xpn.xwiki.cache.api.XWikiCache;
 import com.xpn.xwiki.cache.api.XWikiCacheNeedsRefreshException;
@@ -206,7 +208,7 @@
     private XWikiCache virtualWikiMap;
 
     private static Map threadMap = new HashMap();
-
+    
     private boolean isReadOnly = false;
 
     public static final String CFG_ENV_NAME = "XWikiConfig";
@@ -1435,7 +1437,7 @@
         }
         try {
             if (skin.indexOf(".") != -1) {
-                if (!getRightService().hasAccessLevel("view", context.getUser(), skin, context))
+                if (!getRightService().hasAccessLevel(AccessLevel.VIEW, context.getUser(), skin, context))
                     skin = Param("xwiki.defaultskin", getDefaultBaseSkin(context));
             }
         } catch (XWikiException e) {
@@ -3011,11 +3013,23 @@
     {
         return getAuthService().checkAuth(context);
     }
-
+    
+    /**
+     * @see XWiki#checkAccess(DocumentAction, XWikiDocument, XWikiContext)
+     * 
+     * @deprecated use {@link XWiki#checkAccess(DocumentAction, XWikiDocument, XWikiContext)}
+     */
     public boolean checkAccess(String action, XWikiDocument doc, XWikiContext context)
         throws XWikiException
     {
-        if (action.equals("skin") && doc.getSpace().equals("skins"))
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.checkAccess(documentAction, doc, context);
+    }    
+    
+    public boolean checkAccess(DocumentAction action, XWikiDocument doc, XWikiContext context)
+        throws XWikiException
+    {
+        if (action.equals(DocumentAction.SKIN) && doc.getSpace().equals("skins"))
             return true;
         return getRightService().checkAccess(action, doc, context);
     }
@@ -3088,7 +3102,7 @@
                 doc =
                     getDocument(((XWikiDocument) context.get("doc")).getSpace(), topic, context);
 
-                if (checkAccess("view", doc, context) == false) {
+                if (checkAccess(DocumentAction.VIEW, doc, context) == false) {
                     throw new XWikiException(XWikiException.MODULE_XWIKI_ACCESS,
                         XWikiException.ERROR_XWIKI_ACCESS_DENIED,
                         "Access to this document is denied");
@@ -3641,7 +3655,7 @@
             return null;
     }
 
-    public String getURL(String fullname, String action, XWikiContext context)
+    public String getURL(String fullname, DocumentAction action, XWikiContext context)
         throws XWikiException
     {
         XWikiDocument doc = new XWikiDocument();
@@ -3652,10 +3666,21 @@
                 doc.getDatabase(), context);
         return context.getURLFactory().getURL(url, context);
     }
-
-    public String getExternalURL(String fullname, String action, XWikiContext context)
+    
+    /**
+     * @see XWiki#getURL(String, DocumentAction, XWikiContext)
+     * @deprecated use {@link XWiki#getURL(String, DocumentAction, XWikiContext)}
+     */
+    public String getURL(String fullname, String action, XWikiContext context)
         throws XWikiException
     {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getURL(fullname, documentAction, context);
+    }
+    
+    public String getExternalURL(String fullname, DocumentAction action, XWikiContext context)
+        throws XWikiException
+    {
         XWikiDocument doc = new XWikiDocument();
         doc.setFullName(fullname, context);
 
@@ -3664,8 +3689,19 @@
                 null, null, doc.getDatabase(), context);
         return url.toString();
     }
+    
+    /**
+     * @see XWiki#getExternalURL(String, DocumentAction, XWikiContext)
+     * @deprecated use {@link XWiki#getExternalURL(String, DocumentAction, XWikiContext)} 
+     */
+    public String getExternalURL(String fullname, String action, XWikiContext context)
+        throws XWikiException     
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getExternalURL(fullname, documentAction, context);
+    }
 
-    public String getExternalURL(String fullname, String action, String querystring,
+    public String getExternalURL(String fullname, DocumentAction action, String querystring,
         XWikiContext context) throws XWikiException
     {
         XWikiDocument doc = new XWikiDocument();
@@ -3676,10 +3712,21 @@
                 querystring, null, doc.getDatabase(), context);
         return url.toString();
     }
-
-    public String getURL(String fullname, String action, String querystring, XWikiContext context)
-        throws XWikiException
+    
+    /**
+     *  @see XWiki#getExternalURL(String, DocumentAction, String, XWikiContext)
+     *  @deprecated  use {@link XWiki#getExternalURL(String, DocumentAction, String, XWikiContext)}
+     */
+    public String getExternalURL(String fullname, String action, String querystring,
+        XWikiContext context) throws XWikiException
     {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getExternalURL(fullname, documentAction, querystring, context);
+    }
+    
+    public String getURL(String fullname, DocumentAction action, String querystring,
+        XWikiContext context) throws XWikiException
+    {
         XWikiDocument doc = new XWikiDocument();
         doc.setFullName(fullname, context);
 
@@ -3688,13 +3735,24 @@
                 null, doc.getDatabase(), context);
         return context.getURLFactory().getURL(url, context);
     }
-
+    
+    /**
+     * @see XWiki#getURL(String, DocumentAction, String, XWikiContext)
+     * @deprecated use {@link XWiki#getURL(String, DocumentAction, String, XWikiContext)} 
+     */
+    public String getURL(String fullname, String action, String querystring,
+        XWikiContext context) throws XWikiException 
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getURL(fullname, documentAction, querystring, context);
+    }
+    
     public String getAttachmentURL(String fullname, String filename, XWikiContext context)
         throws XWikiException
     {
         XWikiDocument doc = new XWikiDocument();
         doc.setFullName(fullname, context);
-        return doc.getAttachmentURL(filename, "download", context);
+        return doc.getAttachmentURL(filename, DocumentAction.DOWNLOAD, context);
     }
 
     // Usefull date functions
@@ -3771,9 +3829,9 @@
         } else if (context.getMode() == XWikiContext.MODE_XMLRPC) {
             docname = context.getDoc().getFullName();
         } else {
-            String action = context.getAction();
+            DocumentAction action = context.getAction();
             if ((request.getParameter("topic") != null)
-                && (action.equals("edit") || action.equals("inline")))
+                && (action.equals(DocumentAction.EDIT) || action.equals(DocumentAction.INLINE)))
                 docname = request.getParameter("topic");
             else {
                 // TODO: Introduce a XWikiURL class in charge of getting the information relevant
@@ -3843,7 +3901,7 @@
         XWikiDocument doc;
         context.getWiki().prepareResources(context);
         String docName = getDocumentName(request, context);
-        if (context.getAction().equals("register")) {
+        if (context.getAction().equals(DocumentAction.REGISTER)) {
             setPhonyDocument(docName, context, vcontext);
             doc = context.getDoc();
         } else {
@@ -3851,11 +3909,11 @@
                 doc = getDocument(docName, context);
             } catch (XWikiException e) {
                 doc = context.getDoc();
-                if (context.getAction().equals("delete")) {
+                if (context.getAction().equals(DocumentAction.DELETE)) {
                     if (doc == null) {
                         setPhonyDocument(docName, context, vcontext);
                     }
-                    if (!checkAccess("admin", doc, context)) {
+                    if (!checkAccess(DocumentAction.ADMIN, doc, context)) {
                         throw e;
                     }
                 } else {
@@ -4327,8 +4385,8 @@
             if (link == false)
                 return text;
             else {
-                return "<span class=\"wikilink\"><a href=\"" + userdoc.getURL("view", context)
-                    + "\">" + text + "</a></span>";
+                return "<span class=\"wikilink\"><a href=\""
+                    + userdoc.getURL(DocumentAction.VIEW, context) + "\">" + text + "</a></span>";
             }
         } catch (Exception e) {
             e.printStackTrace();
@@ -5393,7 +5451,7 @@
     {
         XWikiDocument doc = new XWikiDocument();
         doc.setFullName(fullName, context);
-        return doc.getExternalAttachmentURL(filename, "download", context);
+        return doc.getExternalAttachmentURL(filename, DocumentAction.DOWNLOAD, context);
     }
 
     public int getMaxRecursiveSpaceChecks(XWikiContext context)
